<?php
/**
 * Plugin Name:       Pofily - WooCommerce Product Filters Premium
 * Plugin URI:        https://www.persianscript.ir
 * Description:       Pofily - WooCommerce Product Filter is an expert at filtering products. With just a few clicks of the filter, customers can quickly link to desired products.
 * Version:           1.1.8.1
 * Author:            پرشین اسکریپت
 * Author URI:        https://www.persianscript.ir
 * Text Domain:       pofily-woocommerce-product-filters
 * Domain Path:       /languages
 * Copyright 2021-2023 VillaTheme.com. All rights reserved.
 * Tested up to: 6.2.0
 * Elementor tested up to: 3.7.3
 * WC tested up to: 7.7.1
 * Requires PHP: 7.0
 */


if ( ! defined( 'ABSPATH' ) ) {
	exit;
}
include_once( ABSPATH . 'wp-admin/includes/plugin.php' );


/**
 * Currently plugin version.
 */
define( 'VIWCPF_VERSION', '1.1.8.1' );
define( 'VIWCPF_DIR_PATH', plugin_dir_path( __FILE__ ) );
define( 'VIWCPF_DIR_URL', plugin_dir_url( __FILE__ ) );
define( 'VIWCPF_ADMIN_IMG_URL', VIWCPF_DIR_URL . 'admin/images/' );
define( 'VIWCPF_CSS', VIWCPF_DIR_URL . 'assets/css/' );
define( 'VIWCPF_BASE_NAME', plugin_basename( __FILE__ ) );
define( 'VIWCPF_DIR_INCLUDES', VIWCPF_DIR_PATH . "includes" . DIRECTORY_SEPARATOR );
require_once VIWCPF_DIR_PATH . 'includes/update.php';
require_once VIWCPF_DIR_PATH . 'includes/check_update.php';
require_once VIWCPF_DIR_PATH . 'includes/support.php';
if ( is_file( VIWCPF_DIR_INCLUDES . '3rd/elementor/elementor.php' ) ) {
	require_once VIWCPF_DIR_INCLUDES . '3rd/elementor/elementor.php';
}


/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-woocommerce-product-filters-activator.php
 */
function viwcpf_activate_woocommerce_product_filters() {

	require_once VIWCPF_DIR_PATH . 'includes/class-woocommerce-product-filters-activator.php';
	VIWCPF_Woocommerce_Product_Filters_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-woocommerce-product-filters-deactivator.php
 */
function viwcpf_deactivate_woocommerce_product_filters() {
	require_once VIWCPF_DIR_PATH . 'includes/class-woocommerce-product-filters-deactivator.php';
	VIWCPF_Woocommerce_Product_Filters_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'viwcpf_activate_woocommerce_product_filters' );
register_deactivation_hook( __FILE__, 'viwcpf_deactivate_woocommerce_product_filters' );

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */


require VIWCPF_DIR_PATH . 'includes/class-woocommerce-product-filters.php';
if ( is_file( VIWCPF_DIR_INCLUDES . '3rd/multi-currency.php' ) ) {
	require_once VIWCPF_DIR_INCLUDES . '3rd/multi-currency.php';
}

//compatible with 'High-Performance order storage (COT)
add_action( 'before_woocommerce_init', function() {
	if ( class_exists( \Automattic\WooCommerce\Utilities\FeaturesUtil::class ) ) {
		\Automattic\WooCommerce\Utilities\FeaturesUtil::declare_compatibility( 'custom_order_tables', __FILE__, true );
	}
} );
/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.0
 */
function viwcpf_run_woocommerce_product_filters() {

	$plugin = new VIWCPF_Woocommerce_Product_Filters();
	$plugin->run();


}

viwcpf_run_woocommerce_product_filters();
